/** @file timing.h
  * @brief Timing functions declarations / defines.
  *
  *	This file does only exist because the timer that GLUT uses 
  *	in Windows to get GLUT_ELAPSED_TIME seems
  *	to be too imprecise. Plus, the precision seems to differ 
  *	with Windows versions (my old Win98SE behaves different
  *	from a Windows 2000 machine).
  *	The only other GLUT implementation that was tested is my development
  *	system, Linux. Works perfectly there.
  */

#ifndef timing_include
#define timing_include

#ifdef _MSC_VER
void		initTimer();
int			getElapsedTime();

#else
#define		getElapsedTime()	glutGet(GLUT_ELAPSED_TIME)
#endif

#endif
